/** @file cmdline.h
 *  @brief The header file for the command line option parser
 *  generated by GNU Gengetopt version 2.22.6
 *  http://www.gnu.org/software/gengetopt.
 *  DO NOT modify this file, since it can be overwritten
 *  @author GNU Gengetopt by Lorenzo Bettini */

#ifndef CMDLINE_H
#define CMDLINE_H

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h> /* for FILE */

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#ifndef CMDLINE_PARSER_PACKAGE
/** @brief the program name (used for printing errors) */
#define CMDLINE_PARSER_PACKAGE "dcp"
#endif

#ifndef CMDLINE_PARSER_PACKAGE_NAME
/** @brief the complete program name (used for help and version) */
#define CMDLINE_PARSER_PACKAGE_NAME "dcp"
#endif

#ifndef CMDLINE_PARSER_VERSION
/** @brief the program version */
#define CMDLINE_PARSER_VERSION "1.0.6"
#endif

/** @brief Where the command line options are stored */
struct cmdline_info
{
  const char *help_help; /**< @brief Print help and exit help description.  */
  const char *version_help; /**< @brief Print version and exit help description.  */
  int all_flag;	/**< @brief same as -mstu (default=off).  */
  const char *all_help; /**< @brief same as -mstu help description.  */
  int md5_flag;	/**< @brief generate md5 (default=off).  */
  const char *md5_help; /**< @brief generate md5 help description.  */
  int sha1_flag;	/**< @brief generate sha1 (default=off).  */
  const char *sha1_help; /**< @brief generate sha1 help description.  */
  int sha256_flag;	/**< @brief generate sha256 (default=off).  */
  const char *sha256_help; /**< @brief generate sha256 help description.  */
  int sha512_flag;	/**< @brief generate sha512 (default=off).  */
  const char *sha512_help; /**< @brief generate sha512 help description.  */
  char * output_arg;	/**< @brief where to write output.  */
  char * output_orig;	/**< @brief where to write output original value given at command line.  */
  const char *output_help; /**< @brief where to write output help description.  */
  char ** input_arg;	/**< @brief output from a previous run to check for uniqueness.  */
  char ** input_orig;	/**< @brief output from a previous run to check for uniqueness original value given at command line.  */
  unsigned int input_min; /**< @brief output from a previous run to check for uniqueness's minimum occurreces */
  unsigned int input_max; /**< @brief output from a previous run to check for uniqueness's maximum occurreces */
  const char *input_help; /**< @brief output from a previous run to check for uniqueness help description.  */
  char * xattr_arg;	/**< @brief where to write eXtended ATTRibutes.  */
  char * xattr_orig;	/**< @brief where to write eXtended ATTRibutes original value given at command line.  */
  const char *xattr_help; /**< @brief where to write eXtended ATTRibutes help description.  */
  char * owner_arg;	/**< @brief username to chown new files/dirs.  */
  char * owner_orig;	/**< @brief username to chown new files/dirs original value given at command line.  */
  const char *owner_help; /**< @brief username to chown new files/dirs help description.  */
  char * group_arg;	/**< @brief group to chown new files/dirs.  */
  char * group_orig;	/**< @brief group to chown new files/dirs original value given at command line.  */
  const char *group_help; /**< @brief group to chown new files/dirs help description.  */
  char * cache_size_arg;	/**< @brief amount of memory to set aside for caching files.  */
  char * cache_size_orig;	/**< @brief amount of memory to set aside for caching files original value given at command line.  */
  const char *cache_size_help; /**< @brief amount of memory to set aside for caching files help description.  */
  int verbose_flag;	/**< @brief explain what is being done (default=off).  */
  const char *verbose_help; /**< @brief explain what is being done help description.  */
  int debug_flag;	/**< @brief output debugging information (default=off).  */
  const char *debug_help; /**< @brief output debugging information help description.  */
  
  unsigned int help_given ;	/**< @brief Whether help was given.  */
  unsigned int version_given ;	/**< @brief Whether version was given.  */
  unsigned int all_given ;	/**< @brief Whether all was given.  */
  unsigned int md5_given ;	/**< @brief Whether md5 was given.  */
  unsigned int sha1_given ;	/**< @brief Whether sha1 was given.  */
  unsigned int sha256_given ;	/**< @brief Whether sha256 was given.  */
  unsigned int sha512_given ;	/**< @brief Whether sha512 was given.  */
  unsigned int output_given ;	/**< @brief Whether output was given.  */
  unsigned int input_given ;	/**< @brief Whether input was given.  */
  unsigned int xattr_given ;	/**< @brief Whether xattr was given.  */
  unsigned int owner_given ;	/**< @brief Whether owner was given.  */
  unsigned int group_given ;	/**< @brief Whether group was given.  */
  unsigned int cache_size_given ;	/**< @brief Whether cache-size was given.  */
  unsigned int verbose_given ;	/**< @brief Whether verbose was given.  */
  unsigned int debug_given ;	/**< @brief Whether debug was given.  */

  char **inputs ; /**< @brief unamed options (options without names) */
  unsigned inputs_num ; /**< @brief unamed options number */
} ;

/** @brief The additional parameters to pass to parser functions */
struct cmdline_parser_params
{
  int override; /**< @brief whether to override possibly already present options (default 0) */
  int initialize; /**< @brief whether to initialize the option structure cmdline_info (default 1) */
  int check_required; /**< @brief whether to check that all required options were provided (default 1) */
  int check_ambiguity; /**< @brief whether to check for options already specified in the option structure cmdline_info (default 0) */
  int print_errors; /**< @brief whether getopt_long should print an error message for a bad option (default 1) */
} ;

/** @brief the purpose string of the program */
extern const char *cmdline_info_purpose;
/** @brief the usage string of the program */
extern const char *cmdline_info_usage;
/** @brief the description string of the program */
extern const char *cmdline_info_description;
/** @brief all the lines making the help output */
extern const char *cmdline_info_help[];

/**
 * The command line parser
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser (int argc, char **argv,
  struct cmdline_info *args_info);

/**
 * The command line parser (version with additional parameters - deprecated)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param override whether to override possibly already present options
 * @param initialize whether to initialize the option structure my_args_info
 * @param check_required whether to check that all required options were provided
 * @return 0 if everything went fine, NON 0 if an error took place
 * @deprecated use cmdline_parser_ext() instead
 */
int cmdline_parser2 (int argc, char **argv,
  struct cmdline_info *args_info,
  int override, int initialize, int check_required);

/**
 * The command line parser (version with additional parameters)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param params additional parameters for the parser
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser_ext (int argc, char **argv,
  struct cmdline_info *args_info,
  struct cmdline_parser_params *params);

/**
 * Save the contents of the option struct into an already open FILE stream.
 * @param outfile the stream where to dump options
 * @param args_info the option struct to dump
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser_dump(FILE *outfile,
  struct cmdline_info *args_info);

/**
 * Save the contents of the option struct into a (text) file.
 * This file can be read by the config file parser (if generated by gengetopt)
 * @param filename the file where to save
 * @param args_info the option struct to save
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser_file_save(const char *filename,
  struct cmdline_info *args_info);

/**
 * Print the help
 */
void cmdline_parser_print_help(void);
/**
 * Print the version
 */
void cmdline_parser_print_version(void);

/**
 * Initializes all the fields a cmdline_parser_params structure 
 * to their default values
 * @param params the structure to initialize
 */
void cmdline_parser_params_init(struct cmdline_parser_params *params);

/**
 * Allocates dynamically a cmdline_parser_params structure and initializes
 * all its fields to their default values
 * @return the created and initialized cmdline_parser_params structure
 */
struct cmdline_parser_params *cmdline_parser_params_create(void);

/**
 * Initializes the passed cmdline_info structure's fields
 * (also set default values for options that have a default)
 * @param args_info the structure to initialize
 */
void cmdline_parser_init (struct cmdline_info *args_info);
/**
 * Deallocates the string fields of the cmdline_info structure
 * (but does not deallocate the structure itself)
 * @param args_info the structure to deallocate
 */
void cmdline_parser_free (struct cmdline_info *args_info);

/**
 * Checks that all the required options were specified
 * @param args_info the structure to check
 * @param prog_name the name of the program that will be used to print
 *   possible errors
 * @return
 */
int cmdline_parser_required (struct cmdline_info *args_info,
  const char *prog_name);


#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* CMDLINE_H */
